/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the MailchimpControllerActionDc200ResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MailchimpControllerActionDc200ResponseInner{}

// MailchimpControllerActionDc200ResponseInner struct for MailchimpControllerActionDc200ResponseInner
type MailchimpControllerActionDc200ResponseInner struct {
	Key   *string `json:"key,omitempty"`
	Value *string `json:"value,omitempty"`
}

// NewMailchimpControllerActionDc200ResponseInner instantiates a new MailchimpControllerActionDc200ResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMailchimpControllerActionDc200ResponseInner() *MailchimpControllerActionDc200ResponseInner {
	this := MailchimpControllerActionDc200ResponseInner{}
	return &this
}

// NewMailchimpControllerActionDc200ResponseInnerWithDefaults instantiates a new MailchimpControllerActionDc200ResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMailchimpControllerActionDc200ResponseInnerWithDefaults() *MailchimpControllerActionDc200ResponseInner {
	this := MailchimpControllerActionDc200ResponseInner{}
	return &this
}

// GetKey returns the Key field value if set, zero value otherwise.
func (o *MailchimpControllerActionDc200ResponseInner) GetKey() string {
	if o == nil || IsNil(o.Key) {
		var ret string
		return ret
	}
	return *o.Key
}

// GetKeyOk returns a tuple with the Key field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MailchimpControllerActionDc200ResponseInner) GetKeyOk() (*string, bool) {
	if o == nil || IsNil(o.Key) {
		return nil, false
	}
	return o.Key, true
}

// HasKey returns a boolean if a field has been set.
func (o *MailchimpControllerActionDc200ResponseInner) HasKey() bool {
	if o != nil && !IsNil(o.Key) {
		return true
	}

	return false
}

// SetKey gets a reference to the given string and assigns it to the Key field.
func (o *MailchimpControllerActionDc200ResponseInner) SetKey(v string) {
	o.Key = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *MailchimpControllerActionDc200ResponseInner) GetValue() string {
	if o == nil || IsNil(o.Value) {
		var ret string
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MailchimpControllerActionDc200ResponseInner) GetValueOk() (*string, bool) {
	if o == nil || IsNil(o.Value) {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *MailchimpControllerActionDc200ResponseInner) HasValue() bool {
	if o != nil && !IsNil(o.Value) {
		return true
	}

	return false
}

// SetValue gets a reference to the given string and assigns it to the Value field.
func (o *MailchimpControllerActionDc200ResponseInner) SetValue(v string) {
	o.Value = &v
}

func (o MailchimpControllerActionDc200ResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MailchimpControllerActionDc200ResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Key) {
		toSerialize["key"] = o.Key
	}
	if !IsNil(o.Value) {
		toSerialize["value"] = o.Value
	}
	return toSerialize, nil
}

type NullableMailchimpControllerActionDc200ResponseInner struct {
	value *MailchimpControllerActionDc200ResponseInner
	isSet bool
}

func (v NullableMailchimpControllerActionDc200ResponseInner) Get() *MailchimpControllerActionDc200ResponseInner {
	return v.value
}

func (v *NullableMailchimpControllerActionDc200ResponseInner) Set(val *MailchimpControllerActionDc200ResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableMailchimpControllerActionDc200ResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableMailchimpControllerActionDc200ResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMailchimpControllerActionDc200ResponseInner(val *MailchimpControllerActionDc200ResponseInner) *NullableMailchimpControllerActionDc200ResponseInner {
	return &NullableMailchimpControllerActionDc200ResponseInner{value: val, isSet: true}
}

func (v NullableMailchimpControllerActionDc200ResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMailchimpControllerActionDc200ResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
